#include <stdio.h>
#include <string.h>

unsigned char ROM[1024];

static char *Opcodes[256] = {
#include "1802op.h"
};

#define ORIGIN  (0x0000)
#define SIZE	(0x300)

void main()
{
unsigned OrgPC,PC;
char Decode[32],*p1,*p2,Data[32];

FILE *f = fopen("studio2.rom","rb");
unsigned n = fread(ROM,1,2048,f);
fclose(f);

printf(".org %04xh\n",ORIGIN);
printf(".include \"1802.inc\"\n");

PC = ORIGIN;
while (PC < ORIGIN+SIZE)
	{
	OrgPC = PC;
	p1 = Opcodes[ROM[PC-ORIGIN]];
	PC++;
	p2 = Decode;
	while (*p1 != '\0')
		{
		switch(*p1)
			{
			case '?':	n = ROM[PC-ORIGIN];
						PC++;
						sprintf(p2,"0%02xh",n);
						p2 = p2+strlen(p2);
						break;

			case '&':	n = ROM[PC-ORIGIN];
						PC++;
						n = n | (PC & 0xFF00);
						sprintf(p2,"0%04xh",n);
						p2 = p2+strlen(p2);
						break;

			case '!':	n = ROM[PC-ORIGIN];
						PC++;
						n = (n << 8) | ROM[PC-ORIGIN];
						PC++;
						sprintf(p2,"0%04xh",n);
						p2 = p2+strlen(p2);
						break;

			default:	*p2++ = *p1;
						break;
			}
		p1++;
		}
	*p2 = '\0';

	sprintf(Data,"%04x:",OrgPC);
	for (n = OrgPC;n < PC;n++)
		sprintf(Data+strlen(Data),"%02x ",ROM[n-ORIGIN]);

	printf("        %-20s ; %-14s ; \n",Decode,Data);
	}

printf(".end\n");
}

